function [xNew,newExist] = box_resampling(x,exist,NumB)

dim = size(x.x,2);

[xNew.x,choice] = datasample(x.x,NumB,'Weights',x.w);
choice = choice';
newExist = exist(:,choice);
uniqueParticles = unique(choice);
uniqueMat = repmat(uniqueParticles', NumB, 1);
lengthUniqueParticles = length(uniqueParticles);
choiceMat = repmat(choice, 1, lengthUniqueParticles);
numPerParticle = (sum(uniqueMat == choiceMat));
whichSection = repmat(infsup(0,1),NumB,dim);
ri = 1;
for m = 1:length(uniqueParticles)
    if numPerParticle(m) == 1
        xNew.x = xNew.x;
        xNew.w = ones(NumB,1)/NumB;
    elseif numPerParticle(m) <= 2^dim
        u = 2; c = infsup((0:u-1)/u,(1:u)/u)';
        npp = numPerParticle(m);
        while(npp~=0)
            if npp>1
            i = dim; 
            while(npp < 2^i)
                i = i - 1;
            end
            cc = c(fullfact(u*ones(1,i)));
            vind = randperm(dim);
            tt1=(~kron(exist(:,uniqueParticles(m)),ones(5,1))).*(1:length(kron(exist(:,uniqueParticles(m)),ones(5,1))))';
            tt1(tt1==0)=[];
            vind(ismember(vind,tt1)) = [];
            vind = vind(1:i);
            whichSection(ri:ri+size(cc,1)-1,vind) = cc;
            ri = ri +size(cc,1);
            npp = npp - size(cc,1);
            else
            ri = ri + 1;
            npp = 0; 
            end
        end
    else
        error('subdivision error: this has not been developed yet')
    end
end
xNew.x = xNew.x.inf + whichSection.*xNew.x.rad*2;
xNew.w = ones(NumB,1)/NumB;
end