function x = inputFunctionEst(xLast, param, existT, existTNew)
x = xLast;
Ts = 1;
A1 = [1 Ts; 0 1];
A = blkdiag(A1, A1);
G = [Ts^2/2 Ts 0 0; 0 0 Ts^2/2 Ts]';
sizeX = size(x,2);
ni = (randn(sizeX,2).*(repmat([param.sigmaXvH param.sigmaYvH],sizeX,1)*.1 + infsup(-.02,.02)*10))';
noise = repmat([infsup(-3*param.sigmaXvH,3*param.sigmaXvH) infsup(-3*param.sigmaYvH,3*param.sigmaYvH)],sizeX,1)';
noise = G*noise;

randNoise = 0;
if (randNoise)
    Xnew = A*x(1:4,:) + G*(ni);
    rnd = randn(size(xLast.radius.inf));
    x.radius = xLast.radius + param.radiusChangeHypo*rnd + infsup(-param.radiusChangeHypo,param.radiusChangeHypo)*3;
else
    mply = 3;
    Xnew = A*x(1:4,:)+noise;
    Xnew(5,:) = x(5,:) + infsup(-mply*param.radiusChangeHypo,mply*param.radiusChangeHypo);
end
param.radiusMaxEvol = 0.5;
newInf = Xnew(5,:).inf;
newSup = Xnew(5,:).sup;
indx = ~(Xnew(5,:) > param.radiusMinEvol);
newInf(indx) = param.radiusMinEvol;
newInf(newInf > param.radiusMaxEvol) = param.radiusMaxEvol;
indx = ~(Xnew(5,:) < param.radiusMaxEvol);
newSup(indx) = param.radiusMaxEvol;
newSup(newSup < param.radiusMinEvol) = param.radiusMinEvol;
Xnew(5,:) = infsup(newInf, newSup);

particles(1,1) = infsup(-1.5,-0.5);
particles(2,1) = infsup(-0.1,0.1);
particles(3,1) = infsup(-1,0);
particles(4,1) = infsup(-0.1,0.1);
particles(5,1) = infsup(0.05,0.25);

particles(1,2) = infsup(0.5,1.5);
particles(2,2) = infsup(-0.1,0.1);
particles(3,2) = infsup(-1,0);
particles(4,2) = infsup(-0.1,0.1);
particles(5,2) = infsup(0.05,0.25);

particles = datasample(particles,param.numParticles,2);

x(:,(existT == existTNew) & existTNew) = Xnew(:,(existT == existTNew) & existTNew);
x(:,(existT ~= existTNew) & existTNew) = particles(:,(existT ~= existTNew) & existTNew);
end