Nb = 360;
partPrev = particles;
if k ~= 1
    particles = particlesProp;
else
    particlesProp = particles;
end
clustering
clear mm
for l = 1:length(meas)
    mm(l) = length(meas(l).b);
end
mm = [0 mm];

clear('partNew','nanvecT','ContrMeasInd','NonNaNMeasInd','partCon','xInit','xCont')
for Nm = 1:max_targets
    [partNew((5*(Nm-1))+1:5*Nm,:,:)] = contractParticlesA(particles((5*(Nm-1))+1:5*Nm,:), meas, mm,3, grd,partPrev((5*(Nm-1))+1:5*Nm,:),Birth(Nm,:)');
end
partNewBU = partNew;
N = size(partNew,2);
M = size(partNew,3);

nanvec = isnan(partNew);
for Nm = 1:max_targets
    nanvecT((5*(Nm-1))+1:5*Nm,:,:) = repmat(sum(nanvec((5*(Nm-1))+1:5*Nm,:,:))>0,5,1,1);
end
partNew(nanvecT) = NaN;

for Nm = 1:max_targets
    ContrMeasInd(Nm,:,:) = ~isnan(partNew((5*(Nm-1))+1,:,:)) & (sum(partNew((5*(Nm-1))+1:5*Nm,:,:).rad < repmat(particles((5*(Nm-1))+1:5*Nm,:,:).rad,1,1,M))>1);
end
maxclp = 1; 
clear('estX','estXv','estY','estYv','estR');
N_IM = zeros(max_targets,N,max(clusters),5);
temp = NaN*zeros(max_targets,N,max(clusters));
estX = infsup(temp,temp);
estXv = infsup(temp,temp);
estY = infsup(temp,temp);
estYv = infsup(temp,temp);
estR = infsup(temp,temp);
for Nm = 1:max_targets
    for m = 1:N
        for mm = 1:max(clusters)
            if (sum(squeeze(ContrMeasInd(Nm,m,:))& (clusters==mm))==0)
                if sum(squeeze(nanvecT((5*(Nm-1))+1,1,:)) & (clusters==mm))~=sum(clusters==mm)
                    estX(Nm,m,mm) = particles((5*(Nm-1))+1,m);
                    estXv(Nm,m,mm) = particles((5*(Nm-1))+2,m);
                    estY(Nm,m,mm) = particles((5*(Nm-1))+3,m);
                    estYv(Nm,m,mm) = particles((5*(Nm-1))+4,m);
                    estR(Nm,m,mm) = particles((5*(Nm-1))+5,m);
                end
            else
                [estX(Nm,m,mm),N_IM(Nm,m,mm,1)] = intersectR(squeeze(partNew((5*(Nm-1))+1,m,squeeze(ContrMeasInd(Nm,m,:))& (clusters==mm)))',maxclp);
                [estXv(Nm,m,mm),N_IM(Nm,m,mm,2)] = intersectR(squeeze(partNew((5*(Nm-1))+2,m,squeeze(ContrMeasInd(Nm,m,:))& (clusters==mm)))',maxclp);
                [estY(Nm,m,mm),N_IM(Nm,m,mm,3)] = intersectR(squeeze(partNew((5*(Nm-1))+3,m,squeeze(ContrMeasInd(Nm,m,:))& (clusters==mm)))',maxclp);
                [estYv(Nm,m,mm),N_IM(Nm,m,mm,4)] = intersectR(squeeze(partNew((5*(Nm-1))+4,m,squeeze(ContrMeasInd(Nm,m,:))& (clusters==mm)))',maxclp);
                [estR(Nm,m,mm),N_IM(Nm,m,mm,5)] = intersectR(squeeze(partNew((5*(Nm-1))+5,m,squeeze(ContrMeasInd(Nm,m,:))& (clusters==mm)))',maxclp);
            end
        end
    end
end
q_val_pC = repmat(reshape(num_each_cluster,1,1,max(clusters)),max_targets,param.numParticles,1)-(max(N_IM,[],4));%repmat(M-sum(max(q_val,[],4)),max_targets,1,1);
for Nm = 1:max_targets
    partCon((5*(Nm-1))+1,:,:) = estX(Nm,:,:);
    partCon((5*(Nm-1))+2,:,:) = estXv(Nm,:,:);
    partCon((5*(Nm-1))+3,:,:) = estY(Nm,:,:);
    partCon((5*(Nm-1))+4,:,:) = estYv(Nm,:,:);
    partCon((5*(Nm-1))+5,:,:) = estR(Nm,:,:);
end
partNew = squeeze(partCon);
New_Part = []; New_existT = []; New_init_part = [];
clus_sel = [];New_q_pC = [];Cluster_assign = [];
clear('t1','t2');
existPN = ~isnan(estX) & repmat(existT,1,1,max(clusters));
for Nm = 1:param.numParticles
    temp = squeeze(existPN(:,Nm,:));
    
    if(sum(sum(temp,2)>1)>0)
        for jj = max_targets:-1:1
            if jj == max_targets
                t1 = repmat(temp(jj,:),max(clusters),1).*eye(max(clusters));
                t1(all(t1==0,2),:)=[];
                if (size(t1,1)==0)
                    t1 = zeros(1,max(clusters));
                end
            else
                t2 = repmat(temp(jj,:),max(clusters),1).*eye(max(clusters));
                t2(all(t2==0,2),:)=[];
                if (size(t2,1)==0)
                    t2 = zeros(1,max(clusters));
                end
                
                t1 = kron(t1, ones(size(t2,1),1));
                t1 = [repmat(t2,size(t1,1)/size(t2,1),1),t1];
            end
        end
        t1 = reshape(t1',max(clusters),prod(size(t1))/max(clusters))';
    else
        t1 = temp;
    end
    
    for j1 = 1:size(t1,1)/max_targets
        temp = t1((j1-1)*max_targets+1:j1*max_targets,:);
        if(sum(sum(temp)>1)>0)
            t1((j1-1)*max_targets+1:j1*max_targets,:) = [];
            temp = temp';
            for jj = max(clusters):-1:1
                if jj == max(clusters)
                    t11 = repmat(temp(jj,:),max_targets,1).*eye(max_targets);
                    t11(all(t11==0,2),:)=[];
                    if (size(t11,1)==0)
                        t11 = zeros(1,max_targets);
                    end
                else
                    t22 = repmat(temp(jj,:),max_targets,1).*eye(max_targets);
                    t22(all(t22==0,2),:)=[];
                    if (size(t22,1)==0)
                        t22 = zeros(1,max_targets);
                    end
                    
                    t11 = kron(t11, ones(size(t22,1),1));
                    t11 = [repmat(t22,size(t11,1)/size(t22,1),1),t11];
                end
            end
            t11 = reshape(t11',max_targets,prod(size(t11))/max_targets);
            for j2 = 1:size(t11,2)/max(clusters)
                t1 = [t1;t11(:,(j2-1)*max(clusters)+1:j2*max(clusters))];
            end
        end
    end
    
    part_mask = kron(t1,ones(5,1));
    num_part = size(t1,1)/max_targets;
    part_mask = reshape(part_mask,max_targets*5,num_part,max(clusters));
    part_mask2 = double(reshape(t1,max_targets,num_part,max(clusters)));
    col_select = part_mask.*repmat(reshape(1:max(clusters),1,1,max(clusters)),size(part_mask,1),num_part,1);
    col_select2 = part_mask2.*repmat(reshape(1:max(clusters),1,1,max(clusters)),size(part_mask2,1),num_part,1);
    clus_sel = logical(cat(2,clus_sel,col_select(1:5:5*(max_targets),:,:)));
    idx=sum(col_select,3);
    idx(idx==0) = 1;
    part_mask(part_mask == 0) = NaN;
    
    temp = part_mask.*repmat(partNew(:,Nm,:),1,num_part,1);
    idx = sub2ind(size(temp),repmat(1:size(temp,1),num_part,1)',repmat(1:num_part,20,1),idx);
    New_Part = [New_Part,temp(idx)];
    idx=sum(col_select2,3);
    idx(idx==0) = 1;
    
    part_mask2(part_mask2 == 0) = NaN;
    temp = part_mask2.*repmat(q_val_pC(:,Nm,:),1,num_part,1);
    temp2 = part_mask2.*repmat(reshape(1:max(clusters),1,1,max(clusters)),max_targets,size(part_mask2,2),1);
    idx = sub2ind(size(temp),repmat(1:size(temp,1),num_part,1)',repmat(1:num_part,max_targets,1),idx);
    New_q_pC = [New_q_pC,temp(idx)];
    Cluster_assign = [Cluster_assign,temp2(idx)];
    New_existT = [New_existT,repmat(existT(:,Nm),1,num_part)];
    New_init_part = [New_init_part,repmat(particles(:,Nm),1,num_part)];
end

for Nm = 1:size(New_existT,2)
    for Mn = 1:size(New_existT,1)
        if ~isnan(New_Part((5*(Mn-1))+1,Nm))
            xInit(Mn,Nm) = prod(New_init_part((5*(Mn-1))+1:5*Mn,Nm).rad);
            xCont(Mn,Nm) = prod(New_Part((5*(Mn-1))+1:5*Mn,Nm).rad);
        else
            xInit(Mn,Nm) = NaN;
            xCont(Mn,Nm) = NaN;
        end
    end
end
xInit(isnan(xInit))= 1;xInit = prod(xInit);
xCont(isnan(xCont))= 1;xCont = prod(xCont);
q_val = zeros(1,size(Cluster_assign,2));
FP = zeros(1,size(Cluster_assign,2));
for Mn = 1:max(clusters)
    if(sum((sum(Cluster_assign == Mn))>1))
        FP((sum(Cluster_assign == Mn))>1) = Mn;
    end
    q_val(~logical(sum(Cluster_assign == Mn))) = q_val(~logical(sum(Cluster_assign == Mn))) + num_each_cluster(Mn);
end

for Mn = 1:size(Cluster_assign,2)
    if FP(Mn)>0
        temp = min(New_q_pC(Cluster_assign(:,Mn)==FP(Mn),Mn));
        New_q_pC(Cluster_assign(:,Mn)==FP(Mn),Mn) = 0;
        New_q_pC(find(Cluster_assign(:,Mn)==FP(Mn),1,'first'),Mn) = temp;
    end
end

t1 = Cluster_assign;
t1(isnan(t1))=1;
t1=num_each_cluster(t1);
ui = t1 - New_q_pC;
temp = New_Part(5:5:20,:).mid;
temp2 = ui.*log(param.numMeasAv./(2*pi*temp));
temp2(isnan(temp2))=0;
temp2 = sum(temp2);

New_q_pC(isnan(New_q_pC))= 0;
q_val = q_val + sum(New_q_pC);
New_existT = New_existT.*~isnan(Cluster_assign);
temp(isnan(temp))=0;
log_init_w = q_val*log(param.ro)+(M-q_val)*log(param.numMeasAv)...
    +(M-q_val).*log(1./(2*pi*sum(temp)))+log(1./xInit)+log(xCont);
log_init_w(~sum(~isnan(Cluster_assign))) = -inf;

init_w=exp(log_init_w - max(max(log_init_w)));
init_w(isnan(init_w))=0;
w = exp(-1*sum(New_existT)*param.numMeasAv).*(init_w);
w = w/sum(w);

[~,bp] = max(w);
estimate = New_Part(:,bp).mid;
estExistT = ~isnan(estimate(1:5:20));

px.x = New_Part';
px.w = w';
[px,pdist] = box_resampling(px,New_existT, param.numParticles);

existT = pdist;
particles = px.x';
w = px.w';
