max_targets = 4;
param.numMeasAv = 50;               % Average number of measurements
param.gamma = 0.9;
param.numParticles = 32;            % Number of box-particles
param.distanceSigma = 0.025;		% std for the distance measurements uncertainty
param.distanceMeasurementBox = 3*param.distanceSigma;
param.angleSigma = .1*pi/180;		% std for the angle measurements uncertainty
param.angleMeasurementBox = 3*param.angleSigma;         % std for the bearing of the measurements
param.ro = 0.0001;                  % Clutter density
param.sigmaXvH = 0.1;               % std for x velocity for state hypotheses
param.sigmaYvH = 0.1;               % std for y velocity for state hypotheses
param.radiusChangeHypo = .05;	 	% Propagation of the radius of the extend hypotheses
param.radiusMinEvol = 0.001;
param.distanceMeasurementBox = param.distanceMeasurementBox/2;
param.angleMeasurementBox = param.angleMeasurementBox/2;
particles = repmat(infsup(0,0),5*max_targets,param.numParticles);
existT = zeros(max_targets,param.numParticles);existT(1,:) = 1;
Birth = ones(max_targets,param.numParticles);

%Initialise the prior position information
particles(1,1) = infsup(-1.5,-0.5);
particles(2,1) = infsup(-0.1,0.1);
particles(3,1) = infsup(-1,0);
particles(4,1) = infsup(-0.1,0.1);
particles(5,1) = infsup(0,0.3);