% plotCorridor

set(gcf, 'CurrentCharacter', ' ')
xLimArea = [-1.47, -1.47, -1.30, -1.30, -1.47, -1.47, -0.20,  0.20,  1.46, 1.46, 1.30, 1.30, 1.46, 1.46, ...
             0.40,  0.40,  0.05,  0.05, -0.10, -0.10, -0.40, -0.40];
yLimArea = [-0.03, -1.78, -1.78, -1.93, -1.93, -3.80, -5.05, -5.05, -3.80, -1.93, -1.93, -1.78, -1.78, -0.03, ...
            -0.03, -4.00, -4.00, -4.15, -4.15, -4.00, -4.00, -0.03];

fill(xLimArea, yLimArea, 'w')
hold on

pos_laser(:, 1) = [-1.55; 0.00]; 
pos_laser(:, 2) = [1.54; 0.00];  
pos_laser(:, 3) = [0.00; -5.17];
plot(pos_laser(1, 1), pos_laser(2, 1), 'ks', 'MarkerSize', 6, 'MarkerFaceColor', 'b')
plot(pos_laser(1, 2), pos_laser(2, 2), 'ks', 'MarkerSize', 6, 'MarkerFaceColor', 'k')
plot(pos_laser(1, 3), pos_laser(2, 3), 'ks', 'MarkerSize', 6, 'MarkerFaceColor', 'c')
plot(pos_laser(1, :), pos_laser(2, :), 'k+', 'MarkerSize', 12)

axis equal
axis([-2, 2, -6, 1])
box on